
// Interfaces, to be used from generated code!

trait Matrix[T] {
  def numRows: Int
  def numCols: Int

  def apply(m: Int, n: Int): T
  def update(m: Int, n: Int, y: T): Unit
}


// Real data structure, to be used from generated code!

class MatrixImpl[T:Manifest](val numRows: Int, val numCols: Int) extends Matrix[T] {
  val _data = new Array[T](numRows*numCols)

  def apply(m: Int, n: Int) = _data(m*numCols + n)
  def update(m: Int, n: Int, y: T) { _data(m*numCols+n) = y }
}